com.fasterxml.jackson.dataformat.csv

## Class CsvParser

- java.lang.Object
- - com.fasterxml.jackson.core.JsonParser
  - - com.fasterxml.jackson.core.base.ParserMinimalBase
    - - com.fasterxml.jackson.dataformat.csv.CsvParser

- All Implemented Interfaces:
    com.fasterxml.jackson.core.Versioned, Closeable, AutoCloseable

      public class CsvParser
      extends com.fasterxml.jackson.core.base.ParserMinimalBase

  `JsonParser` implementation used to expose CSV documents in form that allows other Jackson functionality to deal with it.

  Implementation is based on a state-machine that pulls information using `CsvDecoder`.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `CsvParser.Feature` Enumeration that defines all togglable features for CSV parsers

    - ### Nested classes/interfaces inherited from class com.fasterxml.jackson.core.JsonParser

      `com.fasterxml.jackson.core.JsonParser.NumberType`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected String` | `_arraySeparator`
    `protected String` | `_arrayValue` Contents of the cell, to be split into distinct array values.
    `protected int` | `_arrayValueStart` Pointer to the first character of the next array value to return.
    `protected byte[]` | `_binaryValue` We will hold on to decoded binary data, for duration of current event, so that multiple calls to `getBinaryValue(com.fasterxml.jackson.core.Base64Variant)` will not need to decode data more than once.
    `protected com.fasterxml.jackson.core.util.ByteArrayBuilder` | `_byteArrayBuilder`
    `protected int` | `_columnCount` Number of columns defined by schema.
    `protected int` | `_columnIndex` Index of the column we are exposing
    `protected String` | `_currentName` Name of column that we exposed most recently, accessible after `JsonToken.FIELD_NAME` as well as value tokens immediately following field name.
    `protected String` | `_currentValue` String value for the current column, if accessed.
    `protected int` | `_formatFeatures`
    `protected String` | `_nullValue`
    `protected com.fasterxml.jackson.core.ObjectCodec` | `_objectCodec` Codec used for data binding when (if) requested.
    `protected com.fasterxml.jackson.core.json.JsonReadContext` | `_parsingContext` Information about parser context, context in which the next token is to be parsed (root, array, object).
    `protected CsvDecoder` | `_reader` Thing that actually reads the CSV content
    `protected CsvSchema` | `_schema` Definition of columns being read.
    `protected int` | `_state` Current logical state of the parser; one of `STATE_` constants.
    `protected TextBuffer` | `_textBuffer` Buffer that contains contents of all values after processing of doubled-quotes, escaped characters.
    `protected static int` | `STATE_DOC_END` State in which end marker is returned; either null (if no array wrapping), or `JsonToken.END_ARRAY` for wrapping.
    `protected static int` | `STATE_DOC_START` Initial state before anything is read from document.
    `protected static int` | `STATE_IN_ARRAY` State in which a column value has been determined to be of an array type, and will need to be split into multiple values.
    `protected static int` | `STATE_MISSING_NAME` State in which we should expose name token for a "missing column" (for which placeholder `null` value is to be added as well); see `CsvParser.Feature.INSERT_NULLS_FOR_MISSING_COLUMNS` for details.
    `protected static int` | `STATE_MISSING_VALUE` State in which we should expose `null` value token as a value for "missing" column; see `CsvParser.Feature.INSERT_NULLS_FOR_MISSING_COLUMNS` for details.
    `protected static int` | `STATE_NAMED_VALUE` State in which value matching field name will be returned.
    `protected static int` | `STATE_NEXT_ENTRY` State in which next entry will be available, returning either `JsonToken.FIELD_NAME` or value (depending on whether entries are expressed as Objects or just Arrays); or matching close marker.
    `protected static int` | `STATE_RECORD_START` State before logical start of a record, in which next token to return will be `JsonToken.START_OBJECT` (or if no Schema is provided, `JsonToken.START_ARRAY`).
    `protected static int` | `STATE_SKIP_EXTRA_COLUMNS` State in which we have encountered more column values than there should be, and need to basically skip extra values if callers tries to advance parser state.
    `protected static int` | `STATE_UNNAMED_VALUE` State in which "unnamed" value (entry in an array) will be returned, if one available; otherwise end-array is returned.

    - ### Fields inherited from class com.fasterxml.jackson.core.base.ParserMinimalBase

      `_currToken, _lastClearedToken, BD_MAX_INT, BD_MAX_LONG, BD_MIN_INT, BD_MIN_LONG, BI_MAX_INT, BI_MAX_LONG, BI_MIN_INT, BI_MIN_LONG, CHAR_NULL, INT_0, INT_9, INT_APOS, INT_ASTERISK, INT_BACKSLASH, INT_COLON, INT_COMMA, INT_CR, INT_e, INT_E, INT_HASH, INT_LBRACKET, INT_LCURLY, INT_LF, INT_MINUS, INT_PERIOD, INT_PLUS, INT_QUOTE, INT_RBRACKET, INT_RCURLY, INT_SLASH, INT_SPACE, INT_TAB, MAX_ERROR_TOKEN_LENGTH, MAX_INT_D, MAX_INT_L, MAX_LONG_D, MIN_INT_D, MIN_INT_L, MIN_LONG_D, NO_BYTES, NO_INTS, NR_BIGDECIMAL, NR_BIGINT, NR_DOUBLE, NR_FLOAT, NR_INT, NR_LONG, NR_UNKNOWN`

    - ### Fields inherited from class com.fasterxml.jackson.core.JsonParser

      `_features, _requestPayload`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CsvParser(CsvIOContext ctxt, int stdFeatures, int csvFeatures, com.fasterxml.jackson.core.ObjectCodec codec, Reader reader)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `com.fasterxml.jackson.core.util.ByteArrayBuilder` | `_getByteArrayBuilder()`
    `protected com.fasterxml.jackson.core.JsonToken` | `_handleArrayValue()`
    `protected void` | `_handleEOF()`
    `protected com.fasterxml.jackson.core.JsonToken` | `_handleExtraColumn(String value)` Helper method called when an extraneous column value is found.
    `protected com.fasterxml.jackson.core.JsonToken` | `_handleMissingColumns()` Helper method called when end of row occurs before finding values for all schema-specified columns.
    `protected com.fasterxml.jackson.core.JsonToken` | `_handleMissingName()`
    `protected com.fasterxml.jackson.core.JsonToken` | `_handleMissingValue()`
    `protected com.fasterxml.jackson.core.JsonToken` | `_handleNamedValue()`
    `protected com.fasterxml.jackson.core.JsonToken` | `_handleNextEntry()`
    `protected com.fasterxml.jackson.core.JsonToken` | `_handleObjectRowEnd()` Helper method called to handle details of state update when end of logical record occurs.
    `protected com.fasterxml.jackson.core.JsonToken` | `_handleRecordStart()`
    `protected com.fasterxml.jackson.core.JsonToken` | `_handleStartDoc()` Method called to handle details of initializing things to return the very first token.
    `protected com.fasterxml.jackson.core.JsonToken` | `_handleUnnamedValue()`
    `protected void` | `_readHeaderLine()` Method called to process the expected header line
    `<T> T` | `_reportCsvMappingError(String msg, Object... args)` Method called when there is a problem related to mapping data (compared to a low-level generation); if so, should be surfaced as
    `void` | `_reportParsingError(String msg)`
    `void` | `_reportUnexpectedCsvChar(int ch, String msg)`
    `protected com.fasterxml.jackson.core.JsonToken` | `_skipUntilEndOfLine()`
    `protected void` | `_startArray(CsvSchema.Column column)`
    `boolean` | `canUseSchema(com.fasterxml.jackson.core.FormatSchema schema)`
    `void` | `close()`
    `com.fasterxml.jackson.core.JsonParser` | `configure(CsvParser.Feature f, boolean state)` Method for enabling or disabling specified CSV feature (check `CsvParser.Feature` for list of features)
    `com.fasterxml.jackson.core.JsonParser` | `disable(CsvParser.Feature f)` Method for disabling specified CSV feature (check `CsvParser.Feature` for list of features)
    `com.fasterxml.jackson.core.JsonParser` | `enable(CsvParser.Feature f)` Method for enabling specified CSV feature (check `CsvParser.Feature` for list of features)
    `BigInteger` | `getBigIntegerValue()`
    `byte[]` | `getBinaryValue(com.fasterxml.jackson.core.Base64Variant variant)`
    `com.fasterxml.jackson.core.ObjectCodec` | `getCodec()`
    `com.fasterxml.jackson.core.JsonLocation` | `getCurrentLocation()`
    `String` | `getCurrentName()`
    `BigDecimal` | `getDecimalValue()`
    `double` | `getDoubleValue()`
    `Object` | `getEmbeddedObject()`
    `float` | `getFloatValue()`
    `int` | `getFormatFeatures()`
    `Object` | `getInputSource()`
    `int` | `getIntValue()`
    `long` | `getLongValue()`
    `com.fasterxml.jackson.core.JsonParser.NumberType` | `getNumberType()`
    `Number` | `getNumberValue()`
    `com.fasterxml.jackson.core.JsonStreamContext` | `getParsingContext()`
    `CsvSchema` | `getSchema()` Accessor for getting active schema definition: it may be "empty" (no column definitions), but will never be null since it defaults to an empty schema (and default configuration)
    `String` | `getText()`
    `int` | `getText(Writer w)`
    `char[]` | `getTextCharacters()`
    `int` | `getTextLength()`
    `int` | `getTextOffset()`
    `com.fasterxml.jackson.core.JsonLocation` | `getTokenLocation()`
    `boolean` | `hasTextCharacters()`
    `boolean` | `isClosed()`
    `boolean` | `isEnabled(CsvParser.Feature f)` Method for checking whether specified CSV `CsvParser.Feature` is enabled.
    `boolean` | `isExpectedStartArrayToken()` We need to override this method to support coercion from basic String value into array, in cases where schema does not specify actual type.
    `String` | `nextFieldName()`
    `boolean` | `nextFieldName(com.fasterxml.jackson.core.SerializableString str)`
    `String` | `nextTextValue()`
    `com.fasterxml.jackson.core.JsonToken` | `nextToken()`
    `void` | `overrideCurrentName(String name)`
    `com.fasterxml.jackson.core.JsonParser` | `overrideFormatFeatures(int values, int mask)`
    `int` | `releaseBuffered(Writer out)`
    `void` | `setCodec(com.fasterxml.jackson.core.ObjectCodec c)`
    `void` | `setSchema(com.fasterxml.jackson.core.FormatSchema schema)`
    `com.fasterxml.jackson.core.Version` | `version()`

    - ### Methods inherited from class com.fasterxml.jackson.core.base.ParserMinimalBase

      `_ascii, _asciiBytes, _constructError, _decodeBase64, _getCharDesc, _handleUnrecognizedCharacterEscape, _hasTextualNull, _reportError, _reportError, _reportError, _reportInvalidEOF, _reportInvalidEOF, _reportInvalidEOF, _reportInvalidEOFInValue, _reportInvalidEOFInValue, _reportMissingRootWS, _reportUnexpectedChar, _throwInternal, _throwInvalidSpace, _throwUnquotedSpace, _wrapError, clearCurrentToken, currentToken, currentTokenId, getCurrentToken, getCurrentTokenId, getLastClearedToken, getValueAsBoolean, getValueAsDouble, getValueAsInt, getValueAsInt, getValueAsLong, getValueAsLong, getValueAsString, getValueAsString, hasCurrentToken, hasToken, hasTokenId, isExpectedStartObjectToken, nextValue, reportInvalidNumber, reportOverflowInt, reportOverflowLong, reportUnexpectedNumberChar, skipChildren`

    - ### Methods inherited from class com.fasterxml.jackson.core.JsonParser

      `_codec, _constructError, _reportUnsupportedOperation, canParseAsync, canReadObjectId, canReadTypeId, configure, disable, enable, finishToken, getBinaryValue, getBooleanValue, getByteValue, getCurrentValue, getFeatureMask, getNonBlockingInputFeeder, getObjectId, getShortValue, getTypeId, getValueAsBoolean, getValueAsDouble, isEnabled, isNaN, nextBooleanValue, nextIntValue, nextLongValue, overrideStdFeatures, readBinaryValue, readBinaryValue, readValueAs, readValueAs, readValueAsTree, readValuesAs, readValuesAs, releaseBuffered, requiresCustomCodec, setCurrentValue, setFeatureMask, setRequestPayloadOnError, setRequestPayloadOnError, setRequestPayloadOnError`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### STATE_DOC_START

          protected static final int STATE_DOC_START

      Initial state before anything is read from document.
      See Also:
        Constant Field Values

    - #### STATE_RECORD_START

          protected static final int STATE_RECORD_START

      State before logical start of a record, in which next token to return will be `JsonToken.START_OBJECT` (or if no Schema is provided, `JsonToken.START_ARRAY`).
      See Also:
        Constant Field Values

    - #### STATE_NEXT_ENTRY

          protected static final int STATE_NEXT_ENTRY

      State in which next entry will be available, returning either `JsonToken.FIELD_NAME` or value (depending on whether entries are expressed as Objects or just Arrays); or matching close marker.
      See Also:
        Constant Field Values

    - #### STATE_NAMED_VALUE

          protected static final int STATE_NAMED_VALUE

      State in which value matching field name will be returned.
      See Also:
        Constant Field Values

    - #### STATE_UNNAMED_VALUE

          protected static final int STATE_UNNAMED_VALUE

      State in which "unnamed" value (entry in an array) will be returned, if one available; otherwise end-array is returned.
      See Also:
        Constant Field Values

    - #### STATE_IN_ARRAY

          protected static final int STATE_IN_ARRAY

      State in which a column value has been determined to be of an array type, and will need to be split into multiple values. This can currently only occur for named values.
      Since:
        2.5
      See Also:
        Constant Field Values

    - #### STATE_SKIP_EXTRA_COLUMNS

          protected static final int STATE_SKIP_EXTRA_COLUMNS

      State in which we have encountered more column values than there should be, and need to basically skip extra values if callers tries to advance parser state.
      Since:
        2.6
      See Also:
        Constant Field Values

    - #### STATE_MISSING_NAME

          protected static final int STATE_MISSING_NAME

      State in which we should expose name token for a "missing column" (for which placeholder `null` value is to be added as well); see `CsvParser.Feature.INSERT_NULLS_FOR_MISSING_COLUMNS` for details.
      Since:
        2.9
      See Also:
        Constant Field Values

    - #### STATE_MISSING_VALUE

          protected static final int STATE_MISSING_VALUE

      State in which we should expose `null` value token as a value for "missing" column; see `CsvParser.Feature.INSERT_NULLS_FOR_MISSING_COLUMNS` for details.
      Since:
        2.9
      See Also:
        Constant Field Values

    - #### STATE_DOC_END

          protected static final int STATE_DOC_END

      State in which end marker is returned; either null (if no array wrapping), or `JsonToken.END_ARRAY` for wrapping. This step will loop, returning series of nulls if `nextToken()` is called multiple times.
      See Also:
        Constant Field Values

    - #### _objectCodec

          protected com.fasterxml.jackson.core.ObjectCodec _objectCodec

      Codec used for data binding when (if) requested.

    - #### _formatFeatures

          protected int _formatFeatures

    - #### _schema

          protected CsvSchema _schema

      Definition of columns being read. Initialized to "empty" instance, which has default configuration settings.

    - #### _columnCount

          protected int _columnCount

      Number of columns defined by schema.

    - #### _parsingContext

          protected com.fasterxml.jackson.core.json.JsonReadContext _parsingContext

      Information about parser context, context in which the next token is to be parsed (root, array, object).

    - #### _currentName

          protected String _currentName

      Name of column that we exposed most recently, accessible after `JsonToken.FIELD_NAME` as well as value tokens immediately following field name.

    - #### _currentValue

          protected String _currentValue

      String value for the current column, if accessed.

    - #### _columnIndex

          protected int _columnIndex

      Index of the column we are exposing

    - #### _state

          protected int _state

      Current logical state of the parser; one of `STATE_` constants.

    - #### _binaryValue

          protected byte[] _binaryValue

      We will hold on to decoded binary data, for duration of current event, so that multiple calls to `getBinaryValue(com.fasterxml.jackson.core.Base64Variant)` will not need to decode data more than once.

    - #### _arrayValueStart

          protected int _arrayValueStart

      Pointer to the first character of the next array value to return.

    - #### _arrayValue

          protected String _arrayValue

      Contents of the cell, to be split into distinct array values.

    - #### _arraySeparator

          protected String _arraySeparator

    - #### _nullValue

          protected String _nullValue

    - #### _reader

          protected final CsvDecoder _reader

      Thing that actually reads the CSV content

    - #### _textBuffer

          protected final TextBuffer _textBuffer

      Buffer that contains contents of all values after processing of doubled-quotes, escaped characters.

    - #### _byteArrayBuilder

          protected com.fasterxml.jackson.core.util.ByteArrayBuilder _byteArrayBuilder

  - ### Constructor Detail

    - #### CsvParser

          public CsvParser(CsvIOContext ctxt,
                   int stdFeatures,
                   int csvFeatures,
                   com.fasterxml.jackson.core.ObjectCodec codec,
                   Reader reader)

  - ### Method Detail

    - #### version

          public com.fasterxml.jackson.core.Version version()

      Specified by:
        `version` in interface `com.fasterxml.jackson.core.Versioned`
      Specified by:
        `version` in class `com.fasterxml.jackson.core.JsonParser`

    - #### getCodec

          public com.fasterxml.jackson.core.ObjectCodec getCodec()

      Specified by:
        `getCodec` in class `com.fasterxml.jackson.core.JsonParser`

    - #### setCodec

          public void setCodec(com.fasterxml.jackson.core.ObjectCodec c)

      Specified by:
        `setCodec` in class `com.fasterxml.jackson.core.JsonParser`

    - #### canUseSchema

          public boolean canUseSchema(com.fasterxml.jackson.core.FormatSchema schema)

      Overrides:
        `canUseSchema` in class `com.fasterxml.jackson.core.JsonParser`

    - #### setSchema

          public void setSchema(com.fasterxml.jackson.core.FormatSchema schema)

      Overrides:
        `setSchema` in class `com.fasterxml.jackson.core.JsonParser`

    - #### releaseBuffered

          public int releaseBuffered(Writer out)
                              throws IOException

      Overrides:
        `releaseBuffered` in class `com.fasterxml.jackson.core.JsonParser`
      Throws:
        `IOException`

    - #### isClosed

          public boolean isClosed()

      Specified by:
        `isClosed` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`

    - #### close

          public void close()
                     throws IOException

      Specified by:
        `close` in interface `Closeable`
      Specified by:
        `close` in interface `AutoCloseable`
      Specified by:
        `close` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`
      Throws:
        `IOException`

    - #### getFormatFeatures

          public int getFormatFeatures()

      Overrides:
        `getFormatFeatures` in class `com.fasterxml.jackson.core.JsonParser`

    - #### overrideFormatFeatures

          public com.fasterxml.jackson.core.JsonParser overrideFormatFeatures(int values,
                                                                     int mask)

      Overrides:
        `overrideFormatFeatures` in class `com.fasterxml.jackson.core.JsonParser`

    - #### enable

          public com.fasterxml.jackson.core.JsonParser enable(CsvParser.Feature f)

      Method for enabling specified CSV feature (check `CsvParser.Feature` for list of features)

    - #### disable

          public com.fasterxml.jackson.core.JsonParser disable(CsvParser.Feature f)

      Method for disabling specified CSV feature (check `CsvParser.Feature` for list of features)

    - #### configure

          public com.fasterxml.jackson.core.JsonParser configure(CsvParser.Feature f,
                                                        boolean state)

      Method for enabling or disabling specified CSV feature (check `CsvParser.Feature` for list of features)

    - #### isEnabled

          public boolean isEnabled(CsvParser.Feature f)

      Method for checking whether specified CSV `CsvParser.Feature` is enabled.

    - #### getSchema

          public CsvSchema getSchema()

      Accessor for getting active schema definition: it may be "empty" (no column definitions), but will never be null since it defaults to an empty schema (and default configuration)
      Overrides:
        `getSchema` in class `com.fasterxml.jackson.core.JsonParser`

    - #### getParsingContext

          public com.fasterxml.jackson.core.JsonStreamContext getParsingContext()

      Specified by:
        `getParsingContext` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`

    - #### getTokenLocation

          public com.fasterxml.jackson.core.JsonLocation getTokenLocation()

      Specified by:
        `getTokenLocation` in class `com.fasterxml.jackson.core.JsonParser`

    - #### getCurrentLocation

          public com.fasterxml.jackson.core.JsonLocation getCurrentLocation()

      Specified by:
        `getCurrentLocation` in class `com.fasterxml.jackson.core.JsonParser`

    - #### getInputSource

          public Object getInputSource()

      Overrides:
        `getInputSource` in class `com.fasterxml.jackson.core.JsonParser`

    - #### isExpectedStartArrayToken

          public boolean isExpectedStartArrayToken()

      We need to override this method to support coercion from basic String value into array, in cases where schema does not specify actual type.
      Overrides:
        `isExpectedStartArrayToken` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`

    - #### getCurrentName

          public String getCurrentName()
                                throws IOException

      Specified by:
        `getCurrentName` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`
      Throws:
        `IOException`

    - #### overrideCurrentName

          public void overrideCurrentName(String name)

      Specified by:
        `overrideCurrentName` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`

    - #### nextToken

          public com.fasterxml.jackson.core.JsonToken nextToken()
                                                         throws IOException

      Specified by:
        `nextToken` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`
      Throws:
        `IOException`

    - #### nextFieldName

          public boolean nextFieldName(com.fasterxml.jackson.core.SerializableString str)
                                throws IOException

      Overrides:
        `nextFieldName` in class `com.fasterxml.jackson.core.JsonParser`
      Throws:
        `IOException`

    - #### nextFieldName

          public String nextFieldName()
                               throws IOException

      Overrides:
        `nextFieldName` in class `com.fasterxml.jackson.core.JsonParser`
      Throws:
        `IOException`

    - #### nextTextValue

          public String nextTextValue()
                               throws IOException

      Overrides:
        `nextTextValue` in class `com.fasterxml.jackson.core.JsonParser`
      Throws:
        `IOException`

    - #### _readHeaderLine

          protected void _readHeaderLine()
                                  throws IOException

      Method called to process the expected header line
      Throws:
        `IOException`

    - #### _handleStartDoc

          protected com.fasterxml.jackson.core.JsonToken _handleStartDoc()
                                                                  throws IOException

      Method called to handle details of initializing things to return the very first token.
      Throws:
        `IOException`

    - #### _handleRecordStart

          protected com.fasterxml.jackson.core.JsonToken _handleRecordStart()
                                                                     throws IOException

      Throws:
        `IOException`

    - #### _handleNextEntry

          protected com.fasterxml.jackson.core.JsonToken _handleNextEntry()
                                                                   throws IOException

      Throws:
        `IOException`

    - #### _handleNamedValue

          protected com.fasterxml.jackson.core.JsonToken _handleNamedValue()
                                                                    throws IOException

      Throws:
        `IOException`

    - #### _handleUnnamedValue

          protected com.fasterxml.jackson.core.JsonToken _handleUnnamedValue()
                                                                      throws IOException

      Throws:
        `IOException`

    - #### _handleArrayValue

          protected com.fasterxml.jackson.core.JsonToken _handleArrayValue()
                                                                    throws IOException

      Throws:
        `IOException`

    - #### _handleExtraColumn

          protected com.fasterxml.jackson.core.JsonToken _handleExtraColumn(String value)
                                                                     throws IOException

      Helper method called when an extraneous column value is found. What happens then depends on configuration, but there are three main choices: ignore value (and rest of line); expose extra value as "any property" using configured name, or throw an exception.
      Throws:
        `IOException`
      Since:
        2.7

    - #### _handleMissingColumns

          protected com.fasterxml.jackson.core.JsonToken _handleMissingColumns()
                                                                        throws IOException

      Helper method called when end of row occurs before finding values for all schema-specified columns.
      Throws:
        `IOException`
      Since:
        2.9

    - #### _handleMissingName

          protected com.fasterxml.jackson.core.JsonToken _handleMissingName()
                                                                     throws IOException

      Throws:
        `IOException`

    - #### _handleMissingValue

          protected com.fasterxml.jackson.core.JsonToken _handleMissingValue()
                                                                      throws IOException

      Throws:
        `IOException`

    - #### _handleObjectRowEnd

          protected final com.fasterxml.jackson.core.JsonToken _handleObjectRowEnd()
                                                                            throws IOException

      Helper method called to handle details of state update when end of logical record occurs.
      Throws:
        `IOException`
      Since:
        2.9

    - #### _skipUntilEndOfLine

          protected final com.fasterxml.jackson.core.JsonToken _skipUntilEndOfLine()
                                                                            throws IOException

      Throws:
        `IOException`

    - #### hasTextCharacters

          public boolean hasTextCharacters()

      Specified by:
        `hasTextCharacters` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`

    - #### getText

          public String getText()
                         throws IOException

      Specified by:
        `getText` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`
      Throws:
        `IOException`

    - #### getTextCharacters

          public char[] getTextCharacters()
                                   throws IOException

      Specified by:
        `getTextCharacters` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`
      Throws:
        `IOException`

    - #### getTextLength

          public int getTextLength()
                            throws IOException

      Specified by:
        `getTextLength` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`
      Throws:
        `IOException`

    - #### getTextOffset

          public int getTextOffset()
                            throws IOException

      Specified by:
        `getTextOffset` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`
      Throws:
        `IOException`

    - #### getText

          public int getText(Writer w)
                      throws IOException

      Overrides:
        `getText` in class `com.fasterxml.jackson.core.JsonParser`
      Throws:
        `IOException`

    - #### getEmbeddedObject

          public Object getEmbeddedObject()
                                   throws IOException

      Overrides:
        `getEmbeddedObject` in class `com.fasterxml.jackson.core.JsonParser`
      Throws:
        `IOException`

    - #### getBinaryValue

          public byte[] getBinaryValue(com.fasterxml.jackson.core.Base64Variant variant)
                                throws IOException

      Specified by:
        `getBinaryValue` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`
      Throws:
        `IOException`

    - #### getNumberType

          public com.fasterxml.jackson.core.JsonParser.NumberType getNumberType()
                                                                         throws IOException

      Specified by:
        `getNumberType` in class `com.fasterxml.jackson.core.JsonParser`
      Throws:
        `IOException`

    - #### getNumberValue

          public Number getNumberValue()
                                throws IOException

      Specified by:
        `getNumberValue` in class `com.fasterxml.jackson.core.JsonParser`
      Throws:
        `IOException`

    - #### getIntValue

          public int getIntValue()
                          throws IOException

      Specified by:
        `getIntValue` in class `com.fasterxml.jackson.core.JsonParser`
      Throws:
        `IOException`

    - #### getLongValue

          public long getLongValue()
                            throws IOException

      Specified by:
        `getLongValue` in class `com.fasterxml.jackson.core.JsonParser`
      Throws:
        `IOException`

    - #### getBigIntegerValue

          public BigInteger getBigIntegerValue()
                                        throws IOException

      Specified by:
        `getBigIntegerValue` in class `com.fasterxml.jackson.core.JsonParser`
      Throws:
        `IOException`

    - #### getFloatValue

          public float getFloatValue()
                              throws IOException

      Specified by:
        `getFloatValue` in class `com.fasterxml.jackson.core.JsonParser`
      Throws:
        `IOException`

    - #### getDoubleValue

          public double getDoubleValue()
                                throws IOException

      Specified by:
        `getDoubleValue` in class `com.fasterxml.jackson.core.JsonParser`
      Throws:
        `IOException`

    - #### getDecimalValue

          public BigDecimal getDecimalValue()
                                     throws IOException

      Specified by:
        `getDecimalValue` in class `com.fasterxml.jackson.core.JsonParser`
      Throws:
        `IOException`

    - #### _handleEOF

          protected void _handleEOF()
                             throws com.fasterxml.jackson.core.JsonParseException

      Specified by:
        `_handleEOF` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`
      Throws:
        `com.fasterxml.jackson.core.JsonParseException`

    - #### _reportCsvMappingError

          public <T> T _reportCsvMappingError(String msg,
                                     Object... args)
                                   throws com.fasterxml.jackson.core.JsonProcessingException

      Method called when there is a problem related to mapping data (compared to a low-level generation); if so, should be surfaced as
      Throws:
        `com.fasterxml.jackson.core.JsonProcessingException`
      Since:
        2.9

    - #### _reportParsingError

          public void _reportParsingError(String msg)
                                   throws com.fasterxml.jackson.core.JsonProcessingException

      Throws:
        `com.fasterxml.jackson.core.JsonProcessingException`

    - #### _reportUnexpectedCsvChar

          public void _reportUnexpectedCsvChar(int ch,
                                      String msg)
                                        throws com.fasterxml.jackson.core.JsonProcessingException

      Throws:
        `com.fasterxml.jackson.core.JsonProcessingException`

    - #### _getByteArrayBuilder

          public com.fasterxml.jackson.core.util.ByteArrayBuilder _getByteArrayBuilder()

    - #### _startArray

          protected void _startArray(CsvSchema.Column column)

Copyright © 2017 FasterXML. All rights reserved.